#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# 񑫕sGhL

require 'dxruby'

$angadd = 2

# ̍W߂NX
class Foot
  def initialize(start_ang)
    @ang = start_ang
    @x = 0
    @y = 0
    self.update
  end

  attr_accessor :x, :y

  def update
    # ~^Ă݂B
    # {͕^̂قƎvc
    # ʓ|L獡͈ɉ~^
    
    ang = @ang * Math::PI / 180.0
    @x = -128 * Math.cos(ang)
    @y = 96 * Math.sin(ang)
    @y = 0 if @y >= 0
    @ang += $angadd
  end
end

# _̕𕡐̃XvCggĕ`
def draw_foot_sub(bx, by, tx, ty, img)
  count = 10
  count.times do |i|
    x = bx + ((tx - bx) * i / (count - 1)) - img.width / 2
    y = by + ((ty - by) * i / (count - 1)) - img.height / 2
    Window.draw(x, y, img)
  end
end

# {`悷
def draw_foot(bx, by, tx, ty, img, flen)
  dw = tx - bx
  dh = ty - by

  # 瑫̐܂ł̒A̔߂
  # O̒藝(s^SX̒藝)gĂ
  l = Math.sqrt(dw * dw + dh * dh) / 2

  # G܂ł̋߂BAO̒藝gĂ
  nl = flen * flen - l * l
  n = (nl <= 0)? 0 : Math.sqrt(nl)

  # Ƒ̒ԓ_߂
  cx = (bx + tx) / 2
  cy = (by + ty) / 2

  # G͂̕(px)߂
  # Ƒ̍Wpx߂āA90x΂
  ang = Math.atan2(dh, dw) + Math::PI / 2
  
  # G̏ꏊ߂
  lx = cx + n * Math.cos(ang)
  ly = cy + n * Math.sin(ang)

  # G܂łƁAG瑫܂ł`
  draw_foot_sub(bx, by, lx, ly, img)
  draw_foot_sub(lx, ly, tx, ty, img)

  # ₷邽߂ɐĂ݂
  Window.drawLine(cx, cy, lx, ly, [255, 0, 0])
end

img = Image.load("ufo.png")

by = 150 # ̍
gy = 420 # nʂ̍

# ̒
flen = (gy - by) / 2 + 20

footl = Foot.new(0)
footr = Foot.new(180)

# C[v
Window.loop do
  break if Input.keyPush?(K_ESCAPE)

  # }EXJ[\yWő̈ړxςĂ݂
  $angadd = 20.0 * Input.mousePosY / Window.height - 10.0
    
  bx = Input.mousePosX

  # E̍Ɛۂ̍W߂
  n = 24
  frbx = bx - n
  frby = by
  frtx = bx + footr.x - n
  frty = footr.y + gy

  # ̍Ɛۂ̍W߂
  flbx = bx + n
  flby = by
  fltx = bx + footl.x + n
  flty = footl.y + gy

  # E`
  draw_foot(frbx, frby, frtx, frty, img, flen)
  
  # `
  Window.drawScale(bx - img.width / 2, by - 80 , img, 2, 2)

  # `
  draw_foot(flbx, flby, fltx, flty, img, flen)

  # ̍WXV
  footl.update
  footr.update

  # ₷邽߂ɐĂ݂
  Window.drawLine(frbx, frby, frtx, frty, [0, 255, 255])
  Window.drawLine(flbx, flby, fltx, flty, [0, 255, 255])
end


